var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

import React from 'react';
import { pick, omit } from 'lodash';

function propTypesAny() {
  return null;
}

export let Context = (_temp = _class = class Context extends React.Component {

  getChildContext() {
    return {
      reactDatavizContext: omit(this.props, ['children'])
    };
  }

  render() {
    return React.Children.only(this.props.children);
  }
}, _class.childContextTypes = {
  reactDatavizContext: propTypesAny
}, _temp);

export function inject(...contextKeys) {
  return InjectedComponent => {
    var _class2, _temp2;

    return _temp2 = _class2 = class Injector extends React.Component {

      render() {
        const props = _extends({}, pick(this.context.reactDatavizContext, contextKeys), this.props);
        return React.createElement(InjectedComponent, props);
      }
    }, _class2.contextTypes = {
      reactDatavizContext: propTypesAny
    }, _temp2;
  };
}

export function injectRescale(...args) {
  return inject('rescale')(...args);
}