'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Circles = exports.Circle = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _context = require('../context');

var _series = require('./series');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Circle = (0, _context.inject)('scales')(function (_ref) {
  var scales = _ref.scales,
      x = _ref.x,
      y = _ref.y,
      _ref$r = _ref.r,
      r = _ref$r === undefined ? 7 : _ref$r,
      otherProps = _objectWithoutProperties(_ref, ['scales', 'x', 'y', 'r']);

  return _react2.default.createElement('circle', _extends({ cx: scales.x(x), cy: scales.y(y), r: r }, otherProps));
});

exports.Circle = Circle;
var Circles = exports.Circles = (0, _series.series)(Circle);