var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { observable, action, computed, autorun, toJS } from 'mobx';

const LEFT_BUTTON = 1;
const RIGHT_BUTTON = 2;
const MIDDLE_BUTTON = 4;

let ReactiveMouse = (_class = class ReactiveMouse {
  constructor() {
    _initDefineProp(this, 'x', _descriptor, this);

    _initDefineProp(this, 'y', _descriptor2, this);

    _initDefineProp(this, 'sx', _descriptor3, this);

    _initDefineProp(this, 'sy', _descriptor4, this);

    _initDefineProp(this, 'clickLeft', _descriptor5, this);

    _initDefineProp(this, 'clickRight', _descriptor6, this);

    _initDefineProp(this, 'clickMiddle', _descriptor7, this);
  }

  get click() {
    return this.clickLeft;
  }
  fromEvent(event, rescale = null) {
    this.x = event.clientX;
    this.y = event.clientY;
    if (rescale) {
      this.sx = rescale.inverse.x(this.x);
      this.sy = rescale.inverse.y(this.y);
    }
    this.clickLeft = (event.buttons & LEFT_BUTTON) > 0;
    this.clickRight = (event.buttons & RIGHT_BUTTON) > 0;
    this.clickMiddle = (event.buttons & MIDDLE_BUTTON) > 0;
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'x', [observable], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'y', [observable], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'sx', [observable], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'sy', [observable], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'click', [computed], Object.getOwnPropertyDescriptor(_class.prototype, 'click'), _class.prototype), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'clickLeft', [observable], {
  enumerable: true,
  initializer: function () {
    return false;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'clickRight', [observable], {
  enumerable: true,
  initializer: function () {
    return false;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class.prototype, 'clickMiddle', [observable], {
  enumerable: true,
  initializer: function () {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'fromEvent', [action], Object.getOwnPropertyDescriptor(_class.prototype, 'fromEvent'), _class.prototype)), _class);


export function buildReactiveMouse(...args) {
  const mouse = new ReactiveMouse();
  if (args.includes('debug')) autorun(() => {
    console.debug(toJS(mouse));
  });
  return mouse;
}